/* Monitor.c generated by valac 0.45.3, the Vala compiler
 * generated from Monitor.vala, do not modify */

/*
* Copyright (c) 2013-2017 elementary LLC. (http://launchpad.net/switchboard-plug-applications)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>

#define STARTUP_PORT_TYPE_MONITOR (startup_port_monitor_get_type ())
#define STARTUP_PORT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitor))
#define STARTUP_PORT_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_PORT_TYPE_MONITOR))
#define STARTUP_PORT_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitorIface))

typedef struct _StartupPortMonitor StartupPortMonitor;
typedef struct _StartupPortMonitorIface StartupPortMonitorIface;
enum  {
	STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL,
	STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL,
	STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL,
	STARTUP_PORT_MONITOR_NUM_SIGNALS
};
static guint startup_port_monitor_signals[STARTUP_PORT_MONITOR_NUM_SIGNALS] = {0};

#define STARTUP_BACKEND_TYPE_MONITOR (startup_backend_monitor_get_type ())
#define STARTUP_BACKEND_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor))
#define STARTUP_BACKEND_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))
#define STARTUP_BACKEND_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))

typedef struct _StartupBackendMonitor StartupBackendMonitor;
typedef struct _StartupBackendMonitorClass StartupBackendMonitorClass;
typedef struct _StartupBackendMonitorPrivate StartupBackendMonitorPrivate;
enum  {
	STARTUP_BACKEND_MONITOR_0_PROPERTY,
	STARTUP_BACKEND_MONITOR_NUM_PROPERTIES
};
static GParamSpec* startup_backend_monitor_properties[STARTUP_BACKEND_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _StartupPortMonitorIface {
	GTypeInterface parent_iface;
};

struct _StartupBackendMonitor {
	GObject parent_instance;
	StartupBackendMonitorPrivate * priv;
};

struct _StartupBackendMonitorClass {
	GObjectClass parent_class;
};

struct _StartupBackendMonitorPrivate {
	GFileMonitor* monitor;
};

static gint StartupBackendMonitor_private_offset;
static gpointer startup_backend_monitor_parent_class = NULL;
static StartupPortMonitorIface * startup_backend_monitor_startup_port_monitor_parent_iface = NULL;

GType startup_port_monitor_get_type (void) G_GNUC_CONST;
GType startup_backend_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StartupBackendMonitor, g_object_unref)
StartupBackendMonitor* startup_backend_monitor_new (void);
StartupBackendMonitor* startup_backend_monitor_construct (GType object_type);
static void startup_backend_monitor_setup (StartupBackendMonitor* self);
gchar* startup_utils_get_user_startup_dir (void);
static void startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self,
                                                 GFile* file,
                                                 GFile* dest,
                                                 GFileMonitorEvent event);
static void _startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender,
                                                                         GFile* file,
                                                                         GFile* other_file,
                                                                         GFileMonitorEvent event_type,
                                                                         gpointer self);
gboolean startup_utils_is_desktop_file (const gchar* name);
static void startup_backend_monitor_finalize (GObject * obj);

static void
startup_port_monitor_default_init (StartupPortMonitorIface * iface,
                                   gpointer iface_data)
{
#line 22 "../src/Startup/Backend/Monitor.vala"
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL] = g_signal_new ("file-created", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 22 "../src/Startup/Backend/Monitor.vala"
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL] = g_signal_new ("file-deleted", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 22 "../src/Startup/Backend/Monitor.vala"
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL] = g_signal_new ("file-edited", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 116 "Monitor.c"
}

GType
startup_port_monitor_get_type (void)
{
	static volatile gsize startup_port_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_port_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupPortMonitorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_port_monitor_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType startup_port_monitor_type_id;
		startup_port_monitor_type_id = g_type_register_static (G_TYPE_INTERFACE, "StartupPortMonitor", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (startup_port_monitor_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&startup_port_monitor_type_id__volatile, startup_port_monitor_type_id);
	}
	return startup_port_monitor_type_id__volatile;
}

static inline gpointer
startup_backend_monitor_get_instance_private (StartupBackendMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, StartupBackendMonitor_private_offset);
}

StartupBackendMonitor*
startup_backend_monitor_construct (GType object_type)
{
	StartupBackendMonitor * self = NULL;
#line 33 "../src/Startup/Backend/Monitor.vala"
	self = (StartupBackendMonitor*) g_object_new (object_type, NULL);
#line 34 "../src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_setup (self);
#line 33 "../src/Startup/Backend/Monitor.vala"
	return self;
#line 149 "Monitor.c"
}

StartupBackendMonitor*
startup_backend_monitor_new (void)
{
#line 33 "../src/Startup/Backend/Monitor.vala"
	return startup_backend_monitor_construct (STARTUP_BACKEND_TYPE_MONITOR);
#line 157 "Monitor.c"
}

static void
_startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender,
                                                                    GFile* file,
                                                                    GFile* other_file,
                                                                    GFileMonitorEvent event_type,
                                                                    gpointer self)
{
#line 42 "../src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_on_change_occurred ((StartupBackendMonitor*) self, file, other_file, event_type);
#line 169 "Monitor.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 182 "Monitor.c"
}

static void
startup_backend_monitor_setup (StartupBackendMonitor* self)
{
	gchar* startup_dir = NULL;
	gchar* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 37 "../src/Startup/Backend/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Startup/Backend/Monitor.vala"
	_tmp0_ = startup_utils_get_user_startup_dir ();
#line 38 "../src/Startup/Backend/Monitor.vala"
	startup_dir = _tmp0_;
#line 39 "../src/Startup/Backend/Monitor.vala"
	_tmp1_ = g_file_new_for_path (startup_dir);
#line 39 "../src/Startup/Backend/Monitor.vala"
	file = _tmp1_;
#line 203 "Monitor.c"
	{
		GFileMonitor* _tmp2_ = NULL;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GFileMonitor* _tmp5_;
#line 41 "../src/Startup/Backend/Monitor.vala"
		_tmp3_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 41 "../src/Startup/Backend/Monitor.vala"
		_tmp2_ = _tmp3_;
#line 41 "../src/Startup/Backend/Monitor.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 215 "Monitor.c"
			goto __catch1_g_error;
		}
#line 41 "../src/Startup/Backend/Monitor.vala"
		_tmp4_ = _tmp2_;
#line 41 "../src/Startup/Backend/Monitor.vala"
		_tmp2_ = NULL;
#line 41 "../src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (self->priv->monitor);
#line 41 "../src/Startup/Backend/Monitor.vala"
		self->priv->monitor = _tmp4_;
#line 42 "../src/Startup/Backend/Monitor.vala"
		_tmp5_ = self->priv->monitor;
#line 42 "../src/Startup/Backend/Monitor.vala"
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _startup_backend_monitor_on_change_occurred_g_file_monitor_changed, self, 0);
#line 40 "../src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (_tmp2_);
#line 232 "Monitor.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 40 "../src/Startup/Backend/Monitor.vala"
		e = _inner_error0_;
#line 40 "../src/Startup/Backend/Monitor.vala"
		_inner_error0_ = NULL;
#line 44 "../src/Startup/Backend/Monitor.vala"
		_tmp6_ = string_to_string (startup_dir);
#line 44 "../src/Startup/Backend/Monitor.vala"
		_tmp7_ = g_strconcat ("Failed monitoring startup directory ", _tmp6_, NULL);
#line 44 "../src/Startup/Backend/Monitor.vala"
		_tmp8_ = _tmp7_;
#line 44 "../src/Startup/Backend/Monitor.vala"
		g_warning ("Monitor.vala:44: %s", _tmp8_);
#line 44 "../src/Startup/Backend/Monitor.vala"
		_g_free0 (_tmp8_);
#line 45 "../src/Startup/Backend/Monitor.vala"
		_tmp9_ = e;
#line 45 "../src/Startup/Backend/Monitor.vala"
		_tmp10_ = _tmp9_->message;
#line 45 "../src/Startup/Backend/Monitor.vala"
		g_warning ("Monitor.vala:45: %s", _tmp10_);
#line 40 "../src/Startup/Backend/Monitor.vala"
		_g_error_free0 (e);
#line 265 "Monitor.c"
	}
	__finally1:
#line 40 "../src/Startup/Backend/Monitor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 40 "../src/Startup/Backend/Monitor.vala"
		_g_object_unref0 (file);
#line 40 "../src/Startup/Backend/Monitor.vala"
		_g_free0 (startup_dir);
#line 40 "../src/Startup/Backend/Monitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 40 "../src/Startup/Backend/Monitor.vala"
		g_clear_error (&_inner_error0_);
#line 40 "../src/Startup/Backend/Monitor.vala"
		return;
#line 280 "Monitor.c"
	}
#line 37 "../src/Startup/Backend/Monitor.vala"
	_g_object_unref0 (file);
#line 37 "../src/Startup/Backend/Monitor.vala"
	_g_free0 (startup_dir);
#line 286 "Monitor.c"
}

static void
startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self,
                                            GFile* file,
                                            GFile* dest,
                                            GFileMonitorEvent event)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 49 "../src/Startup/Backend/Monitor.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Startup/Backend/Monitor.vala"
	g_return_if_fail (file != NULL);
#line 50 "../src/Startup/Backend/Monitor.vala"
	_tmp0_ = g_file_get_path (file);
#line 50 "../src/Startup/Backend/Monitor.vala"
	path = _tmp0_;
#line 52 "../src/Startup/Backend/Monitor.vala"
	_tmp1_ = path;
#line 52 "../src/Startup/Backend/Monitor.vala"
	if (startup_utils_is_desktop_file (_tmp1_) == FALSE) {
#line 53 "../src/Startup/Backend/Monitor.vala"
		_g_free0 (path);
#line 53 "../src/Startup/Backend/Monitor.vala"
		return;
#line 314 "Monitor.c"
	}
#line 55 "../src/Startup/Backend/Monitor.vala"
	if (event == G_FILE_MONITOR_EVENT_CREATED) {
#line 318 "Monitor.c"
		const gchar* _tmp2_;
#line 56 "../src/Startup/Backend/Monitor.vala"
		_tmp2_ = path;
#line 56 "../src/Startup/Backend/Monitor.vala"
		g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL], 0, _tmp2_);
#line 324 "Monitor.c"
	} else {
#line 57 "../src/Startup/Backend/Monitor.vala"
		if (event == G_FILE_MONITOR_EVENT_DELETED) {
#line 328 "Monitor.c"
			const gchar* _tmp3_;
#line 58 "../src/Startup/Backend/Monitor.vala"
			_tmp3_ = path;
#line 58 "../src/Startup/Backend/Monitor.vala"
			g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL], 0, _tmp3_);
#line 334 "Monitor.c"
		} else {
#line 59 "../src/Startup/Backend/Monitor.vala"
			if (event == G_FILE_MONITOR_EVENT_CHANGED) {
#line 338 "Monitor.c"
				const gchar* _tmp4_;
#line 60 "../src/Startup/Backend/Monitor.vala"
				_tmp4_ = path;
#line 60 "../src/Startup/Backend/Monitor.vala"
				g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL], 0, _tmp4_);
#line 344 "Monitor.c"
			}
		}
	}
#line 49 "../src/Startup/Backend/Monitor.vala"
	_g_free0 (path);
#line 350 "Monitor.c"
}

static void
startup_backend_monitor_class_init (StartupBackendMonitorClass * klass,
                                    gpointer klass_data)
{
#line 29 "../src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Startup/Backend/Monitor.vala"
	g_type_class_adjust_private_offset (klass, &StartupBackendMonitor_private_offset);
#line 29 "../src/Startup/Backend/Monitor.vala"
	G_OBJECT_CLASS (klass)->finalize = startup_backend_monitor_finalize;
#line 363 "Monitor.c"
}

static void
startup_backend_monitor_startup_port_monitor_interface_init (StartupPortMonitorIface * iface,
                                                             gpointer iface_data)
{
#line 29 "../src/Startup/Backend/Monitor.vala"
	startup_backend_monitor_startup_port_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 372 "Monitor.c"
}

static void
startup_backend_monitor_instance_init (StartupBackendMonitor * self,
                                       gpointer klass)
{
#line 29 "../src/Startup/Backend/Monitor.vala"
	self->priv = startup_backend_monitor_get_instance_private (self);
#line 381 "Monitor.c"
}

static void
startup_backend_monitor_finalize (GObject * obj)
{
	StartupBackendMonitor * self;
#line 29 "../src/Startup/Backend/Monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor);
#line 31 "../src/Startup/Backend/Monitor.vala"
	_g_object_unref0 (self->priv->monitor);
#line 29 "../src/Startup/Backend/Monitor.vala"
	G_OBJECT_CLASS (startup_backend_monitor_parent_class)->finalize (obj);
#line 394 "Monitor.c"
}

GType
startup_backend_monitor_get_type (void)
{
	static volatile gsize startup_backend_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_backend_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupBackendMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendMonitor), 0, (GInstanceInitFunc) startup_backend_monitor_instance_init, NULL };
		static const GInterfaceInfo startup_port_monitor_info = { (GInterfaceInitFunc) startup_backend_monitor_startup_port_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType startup_backend_monitor_type_id;
		startup_backend_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendMonitor", &g_define_type_info, 0);
		g_type_add_interface_static (startup_backend_monitor_type_id, STARTUP_PORT_TYPE_MONITOR, &startup_port_monitor_info);
		StartupBackendMonitor_private_offset = g_type_add_instance_private (startup_backend_monitor_type_id, sizeof (StartupBackendMonitorPrivate));
		g_once_init_leave (&startup_backend_monitor_type_id__volatile, startup_backend_monitor_type_id);
	}
	return startup_backend_monitor_type_id__volatile;
}

